__sfr __at 0x3F port3F;
__sfr __at 0xDC portDC;

static void initMouse()
{
	// Port A TH and TR pins output
	port3F = 0xFC;
}

#define GET_TL()	((portDC) & 0x10)

#define TH_LOW_TR_HIGH()	port3F = 0x1C
#define TH_LOW_TR_LOW()		port3F = 0x0C
#define TH_HIGH_TR_HIGH()	port3F = 0x3C

static void _delay()
{
	volatile uint16_t r = 255;

	while (r--) {
		__asm
		nop
		__endasm;
	}
}

static char detectMouse()
{
	uint16_t t;

	TH_LOW_TR_HIGH();
//	_delay();

	// Handshake

	TH_LOW_TR_LOW();
	t = 1024;
	while (GET_TL()) {
		t--;
		if (!t) {
			port3F = 0xff;
			return 0;
		}
	}

	TH_LOW_TR_HIGH();
	t = 1024;
	while (!GET_TL()) {
		t--;
		if (!t) {
			port3F = 0xff;
			return 0;
		}
	}


	TH_HIGH_TR_HIGH();

	return 1;
}

static void readMouse(uint8_t *dst)
{
	unsigned char i;
	unsigned char tmp;

	TH_LOW_TR_HIGH();
//	_delay();

	for (i=0; i<4; i++) {

		// Receive upper nibble
		TH_LOW_TR_LOW();
		while (GET_TL()) { }
		tmp = portDC & 0xf;
		tmp <<= 4;

		// Receive lower nibble
		TH_LOW_TR_HIGH();
		while (!GET_TL()) { }
		tmp |= portDC & 0xf;

		// Store
		dst[i] = tmp;
	}

	TH_HIGH_TR_HIGH();
}

static void mouseTest(void)
{
	uint8_t mousedata[4];
	int i;
	int c = 0;

	initMouse();
	SMS_autoSetUpTextRenderer();
	SMS_displayOn();

	SMS_setNextTileatXY(0,0);
	printf("Mouse test");

	while(1)
	{
		unsigned int keys, now;

		SMS_waitForVBlank();
		SMS_copySpritestoSAT();

		keys = SMS_getKeysPressed();
		now = SMS_getKeysStatus();

		SMS_setNextTileatXY(0,2);
		if (detectMouse()) {
			printf("Present    ");


			SMS_setNextTileatXY(0,4);
			readMouse(mousedata);

			for (i=0; i<4; i++) {
				printf("%02x ", mousedata[i]);
			}

		} else {
			printf("Not present");
		}


		SMS_setNextTileatXY(0,23);
		printf("%02x", c);

		c++;
		c &= 0xff;

	}

}


/*
		else if (mouse_mode) {
			int8_t mousedata[4];
			// 0: FF
			// 1: Buttons
			// 2: X
			// 3: Y
			readMouse(mousedata);

			px += mousedata[2];
			py += -mousedata[3];

			if (px > MAX_PX) { px = MAX_PX; }
			if (py > MAX_PY) { py = MAX_PY; }
			if (px < 0) { px = 0; }
			if (py < 0) { py = 0; }

			if ((last_px != px) || ( last_py != py)) {
				updateDisplay(px, py, last_px, last_py, 0);

				last_px = px;
				last_py = py;
			}

			drawing = mousedata[1] & 0x01; // left button

			// 0x02 is right button

			if (mousedata[1] & 0x04) { // mid button
				clearDisplay(0);
			}

			if (mousedata[1] & 0x08) { // recessed "start" button
				savedata_commit();
				syncDisplay();
			}

		}

*/
